import RPi.GPIO as GPIO
from time import sleep

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

class Motor():
    def __init__(self, EnaA, In1A, In2A,EnaB, In1B, In2B):
        self.EnaA = EnaA
        self.In1A = In1A
        self.In2A = In2A
        self.EnaB = EnaB
        self.In1B = In1B
        self.In2B = In2B
        print(EnaB,In1B,In2B)
        GPIO.setup(EnaA, GPIO.OUT)
        GPIO.setup(In1A, GPIO.OUT)
        GPIO.setup(In2A, GPIO.OUT)
        GPIO.setup(EnaB, GPIO.OUT)
        GPIO.setup(In1B, GPIO.OUT)
        GPIO.setup(In2B, GPIO.OUT)
        self.pwmA = GPIO.PWM(EnaA, 100)
        self.pwmA.start(0)
        self.pwmB = GPIO.PWM(EnaB, 100)
        self.pwmB.start(0)
        
    def move(self,speed=0.5,turn = 0,t = 0):
        
        if turn > 1:
            turn = 1
        elif turn < -1:
            turn = -1
            
        if turn >0.2:
            print("Turnning Left.. (",turn,")")
        elif turn < -0.2:
            print("Turnning Right.. (",turn,")")
        else:
            if speed > 0:
                print("Going Straight")
            else:
                print("Going backward")
            
            
        #scale 
        speed *= 100
        turn *= 100
        
        #turn : 1 -> right,  0 -> left (-100 to 200)
        leftSpeed = speed - turn
        rightSpeed = speed + turn
        
       
        if leftSpeed > 100:
            leftSpeed = 100
        elif leftSpeed < -100:
            leftSpeed = -100
        if rightSpeed > 100:
            rightSpeed = 100
        elif rightSpeed < -100:
            rightSpeed = -100
            
        self.pwmA.ChangeDutyCycle(abs(leftSpeed))
        self.pwmB.ChangeDutyCycle(abs(rightSpeed))
      
            
          
        if leftSpeed>0:
            GPIO.output(self.In1A,GPIO.HIGH) #Left
            GPIO.output(self.In2A,GPIO.LOW) #Right
        else:
           # leftSpeed = 0
            GPIO.output(self.In1A,GPIO.LOW)
            GPIO.output(self.In2A,GPIO.HIGH)
        
        if rightSpeed>0:
            GPIO.output(self.In1B,GPIO.HIGH)
            GPIO.output(self.In2B,GPIO.LOW)
        else:
          # rifhtSpeed = 0
           GPIO.output(self.In1B,GPIO.LOW)
           GPIO.output(self.In2B,GPIO.HIGH)
        
        #print(f"Speed: {speed:.2f} ,Left: {leftSpeed:.2f} Right: {rightSpeed:.2f} TURN:{turn:.6f}")
        

        sleep(t)


    def stop(self,t=0):
        self.pwmA.ChangeDutyCycle(0)
        self.pwmB.ChangeDutyCycle(0)
        sleep(t)
        
        


def main():
    
    motor1.stop(1)
    motor1.move(0.5,0,10) #turn right
    motor1.stop(1)
    '''
    motor1.move(-1,0,0.5) #turn right
    motor1.stop(1)
    motor1.move(1,1,0.5) #turn right
    motor1.stop(1)
    motor1.move(-1,-1,0.5) #turn right
    motor1.stop(1)
    motor1.move(1,-1,0.5) #turn right
    motor1.stop(1)
    motor1.move(-1,1,0.5) #turn right
    motor1.stop(1)
    
    motor1.move(0.1 , 0,3) #turn right
    motor1.stop(1)
    motor1.move(-0.1,0,3) #turn right
    motor1.stop(1)
    '''
    #motor1.move(0.33,0.8,5) #turn right
    motor1.stop(1)
    
    
import sys
if __name__ == '__main__' :
    print(sys.version)
    
    
    #motor1 = Motor(2,3,4,17,22,27)
    motor1 = Motor(14, 15, 18, 17, 22, 27)
    main()
    